exports.createPopup = ({ serverUrl, clientId, type }, cb) => {
    const url = serverUrl + "/auth/" + type + "?clientId=" + clientId;
    const win = window.open(url, "auth", "width=600,height=600");

    const handler = async (event) => {
        if (event.data.token) {
            cb(event.data.token);
            win.close();
            window.removeEventListener("message", handler);
        }
    };

    window.addEventListener("message", handler);
};

exports.redirectToAuthServer = ({ serverUrl, clientId, type, redirectUrl }) => {
    window.location.href =
        serverUrl +
        "/auth/" +
        type +
        "?clientId=" +
        clientId +
        "&redirectUrl=" +
        redirectUrl;
};

exports.autoLogout = (serverUrl, cb) => {
    window.onload = () => {
        const iframe = document.createElement("iframe");
        iframe.src = serverUrl + "/auth/autologout";
        iframe.style.display = "none";

        document.body.appendChild(iframe);

        let win;
        // some browser (don't remember which one) throw exception when you try to access
        // contentWindow for the first time, it work when you do that second time
        try {
            win = iframe.contentWindow;
        } catch(e) {
            win = iframe.contentWindow;
        }

        window.addEventListener("message", async event => {
            if (event.data.autologout) {
                win.postMessage({autologin: true}, "*");
            }
            if (event.data.autologoutComplete) {
                cb();
            }
        })
    };
}

exports.autoLogin = (serverUrl, cb) => {
    window.onload = () => {
        const iframe = document.createElement("iframe");
        iframe.src = serverUrl + "/auth/autologin";
        iframe.style.display = "none";

        document.body.appendChild(iframe);

        let win;
        // some browser (don't remember which one) throw exception when you try to access
        // contentWindow for the first time, it work when you do that second time
        try {
            win = iframe.contentWindow;
        } catch(e) {
            win = iframe.contentWindow;
        }

        window.addEventListener("message", async event => {
            if (event.data.autologin) {
                win.postMessage({autologin: true}, "*");
            }
            if (event.data.token) {
                cb(event.data.token);
            }
        })
    };
}